Summary: Programs which control basic system processes
Name: sysvinit
Version: 2.86
Release: %mkrel 11
License: GPLv2+
Group: System/Configuration/Boot and Init
Source: ftp://ftp.cistron.nl/pub/people/miquels/sysvinit/sysvinit-%{version}.tar.bz2
URL: ftp://ftp.cistron.nl/pub/people/miquels/sysvinit/
Patch1: sysvinit-2.78-man.patch
Patch2: sysvinit-2.77-md5-be.patch
Patch3: sysvinit-2.78-halt.patch
Patch4: sysvinit-2.86-autofsck.patch
Patch5: sysvinit-2.86-loginshell.patch
Patch6: sysvinit-2.86-makefile.patch
Patch7: sysvinit-2.86-chroot.patch
Patch8: sysvinit-2.86-inittab.patch
Patch9: sysvinit-2.86-environ.patch
Patch10: sysvinit-2.86-pidof.patch
Patch11: sysvinit-2.86-haltname.patch
Patch12: sysvinit-2.86-haltman.patch
Patch13: sysvinit-2.86-single.patch
Patch14: sysvinit-2.86-maxproclen.patch
Patch15: sysvinit-2.86-ipv6.patch
Patch16: sysvinit-2.86-quiet.patch
Patch17: sysvinit-2.86-godot.patch
Patch18: sysvinit-2.86-timeval.patch
Patch19: sysvinit-2.86-console-open.patch
Patch20: sysvinit-selinux.patch
Patch21: sysvinit-no-abort.patch
Patch23: sysvinit-2.86-pidof-man.patch
Patch24: sysvinit-2.86-utmpdump.patch

# Mandriva patches
Patch100: sysvinit-2.86-shutdown.patch
Patch101: sysvinit-2.86-libcrypt.patch
Patch104: sysvinit-2.85-walltty.patch
Patch105: sysvinit-disable-respawn-more-quickly.patch
# from debian
Patch281: 81_killall_avoid_init.dpatch
Patch282: 82_killall_retval.dpatch
Patch283: 82_killall_exclude_pids.dpatch
BuildRequires: glibc-static-devel
Requires: pam >= 0.66-5
Requires(post): coreutils
Obsoletes: SysVinit < 2.86-6mdv2008.1
Provides: SysVinit = %{version}-%{release}
Buildroot: %{_tmppath}/%{name}-%{version}-buildroot

%description
The sysvinit package contains a group of processes that control
the very basic functions of your system. sysvinit includes the init
program, the first program started by the Linux kernel when the
system boots. Init then controls the startup, running, and shutdown
of all other programs.

%prep
%setup -q -n sysvinit-%{version}
# We use a shell, not sulogin. Other random man fixes go here (such as #192804)
%patch1 -p1 -b .manpatch
# Handle bigendian MD5
%patch2 -p1 -b .be
# Create /halt or /poweroff on shutdown
%patch3 -p1 -b .halt
# Unlink /.autofsck on shutdown -f
%patch4 -p1 -b .autofsck
# Invoke single-user shell as a login shell (#105653)
%patch5 -p1 -b .loginshell
# Various makefile adjustments
# %patch6 -p1 -b .makefile
# Add -c option for only matching processes with the same root
%patch7 -p1 -b .chroot
# Adjust examples in inittab(5) to more accurately reflect RH/Fedora
# usage (#173572)
%patch8 -p1 -b .inittabdocs
# Assumedly, if we're passing an environment as the last arg, we
# want execle, not execl.
%patch9 -p1 -b .environ
# Fix various things in pidof - pidof /x/y matching /z/y, pidof -x
# for scripts, etc.
%patch10 -p1 -b .pidof
# Fix halt when called by login
%patch11 -p1 -b .haltname
# Document pam_console usage
%patch12 -p1 -b .haltman
# Fix single user mode (#176348)
%patch13 -p1 -b .single
# Fix under-copy of proc title (#188160)
%patch14 -p1 -b .maxproclen
# ipv6 support in last
%patch15 -p1 -b .ipv6
# Be less verbose when booted with 'quiet'
%patch16 -p1 -b .quiet
# Preserve 'waiting' across re-exec (#199305, #201146, #143289)
%patch17 -p1 -b .godot
# Don't overwrite ut_addr_v6 on 64-bit platforms (#176494)
%patch18 -p1 -b .timeval
# Allow some time for failed opens to resolve themselves (#181546)
%patch19 -p1 -b .console-open
# SELinux support for init - loading policy, etc.
#%patch20 -p1 -b .selinux
# Don't abort if policy is already loaded
#%patch21 -p1 -b .no-abort
# Document some of the behavior of pidof. (#201317)
%patch23 -p1 -b .pidof
# Don't pass around unchecked malloc (and avoid a leak) (#473485)
%patch24 -p1 -b .wheee

%patch100 -p1 -b .shutdown
%patch101 -p1 -b .libcrypt
%patch104 -p1 -b .wall
%patch105 -p1 -b .disable-respawn-more-quickly
%patch281 -p1 -b .killinit
%patch282 -p1 -b .killret
%patch283 -p1 -b .killpids

%build
%make CFLAGS="%{optflags} -D_GNU_SOURCE" LDFLAGS="%{ldflags}" -C src

%install
rm -rf %{buildroot}
for I in bin sbin usr/{bin,include} %{_mandir}/man{1,3,5,8} etc var/run dev; do
	mkdir -p %{buildroot}/$I
done

make -C src ROOT=%{buildroot} MANDIR=%{_mandir} \
	BIN_OWNER=`id -nu` BIN_GROUP=`id -ng` install

# If this already exists, just do nothing (the ||: part)
mknod --mode=0600 %{buildroot}/dev/initctl p ||:
ln -snf killall5 %{buildroot}/sbin/pidof

chmod 755 %{buildroot}/usr/bin/utmpdump

# Remove unpacjaged file(s)
rm -rf	%{buildroot}/usr/include

%post
[ ! -p /dev/initctl ] && rm -f /dev/initctl && mknod --mode=0600 /dev/initctl p || :
[ -e /var/run/initrunlvl ] && ln -s ../var/run/initrunlvl /etc/initrunlvl || :
[ -x /sbin/telinit -a -p /dev/initctl -a -f /proc/1/exe -a -d /proc/1/root ] && /sbin/telinit u || :
exit 0

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc doc/Propaganda doc/Changelog doc/Install
%doc doc/sysvinit-%{version}.lsm contrib/start-stop-daemon.* 
/bin/pidof
/bin/mountpoint
/sbin/bootlogd
/sbin/halt
/sbin/init
/sbin/killall5
/sbin/pidof
/sbin/poweroff
/sbin/reboot
/sbin/runlevel
/sbin/shutdown
/sbin/sulogin
/sbin/telinit
/usr/bin/last
/usr/bin/lastb
/usr/bin/mesg
/usr/bin/utmpdump
%attr(2555,root,tty)  /usr/bin/wall
%{_mandir}/*/*
%ghost /dev/initctl


%changelog
* Thu Jan 29 2009 Frederic Crozat <fcrozat@mandriva.com> 2.86-11mdv2009.1
+ Revision: 335131
- Patch21 (Fedora): Don't abort if policy is already loaded
- Patch22 (Fedora):  Document some of the behavior of pidof. (Fedora bug #201317)
- Patch24 (Fedora): Don't pass around unchecked malloc (and avoid a leak) (Fedora bug #473485)

* Sun Jan 25 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 2.86-10mdv2009.1
+ Revision: 333578
- compile with %%ldflags
- spec file clean

* Mon Dec 22 2008 Oden Eriksson <oeriksson@mandriva.org> 2.86-9mdv2009.1
+ Revision: 317611
- rediffed some fuzzy patches

* Wed Jul 23 2008 Olivier Blin <oblin@mandriva.com> 2.86-8mdv2009.0
+ Revision: 242989
- add more killall5 features (from Debian):
  o never attempt to kill init
  o exit with a proper code
  o "-o" option support to omit pids (to be used by splashy)

* Wed Jun 18 2008 Thierry Vignaud <tvignaud@mandriva.com> 2.86-7mdv2009.0
+ Revision: 225597
- rebuild

* Mon Jan 28 2008 Olivier Blin <oblin@mandriva.com> 2.86-6mdv2008.1
+ Revision: 159196
- require coreutils for post script (#19143)
- obsoletes/provides SysVinit
- rename as sysvinit
- rename SysVinit as sysvinit
- update license tag to GPLv2+
- update URL
- sync with Fedora patches
- remove old cpp hack
- use Fedora's version of timeval/varargs patches
- use Fedora's version of autofsck/chroot patches
- restore BuildRoot

* Mon Dec 17 2007 Thierry Vignaud <tvignaud@mandriva.com> 2.86-5mdv2008.1
+ Revision: 128170
- kill re-definition of %%buildroot on Pixel's request

  + Olivier Blin <oblin@mandriva.com>
    - restore previous SysVinit package


* Sat Sep 15 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 2.86-6mdv2008.0
+ Revision: 85860
- sync patches with fedora (104-113)
- spec file clean
- soec file clean
- rename to be closer with upstream

